<?php

/* 	version 1.2 11-3-2013 
	build for WHMcs v5.3+
*/

if(!function_exists(api_execute)){
	function api_execute($apiurl,$postfields){
	
		$postfields = json_encode($postfields);
	
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $apiurl);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 100);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
		$data = curl_exec($ch);
		if(curl_error($ch)){ 
			$res = "Connection Error: ".curl_errno($ch).' - '.curl_error($ch);
		}else{
			$res = json_decode($data,true);
		}
		curl_close($ch);
		
		return $res;
	}
}

function cloudharddrive_ConfigOptions() {

	# Should return an array of the module options for each product - maximum of 24
	$configarray = array();
	return $configarray;
}

function cloudharddrive_CreateAccount($params) {

    $clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
		
	# Build the API call
	$postfields = array(); 
	$postfields["username"] = $params["serverusername"];
	$postfields["password"] = $params["serverpassword"];
	$postfields["service"] = "cloudharddrive";
	$postfields["reseller"] = $params["serveraccesshash"];		
	if($params["serversecure"] == "on"){ $postfields["testmode"] = "true"; }
	
	$postfields["task"] = "checkavailability";

	if(empty($params["username"])){
		$email = trim($clientsdetails["email"]);
	}else{
		$email = trim($params["username"]);
	}
	$postfields["email"] = $email; 	
			
	/* execute call */
	$res = api_execute($params["serverhostname"],$postfields);
	if(!is_array($res)){
		$result = $res;	
	}elseif($res["result"] == "error"){
		foreach($res["params"] as $code => $error){
			$result .= $code." - ".$error."<br />";
		}
	}else{
		
		$langSet = array ("de-de","en-us","es-es","fr-fr","it-it","ja-jp","nl-be","ja-jp","pl-pl","pt-br","sv-se");
		foreach($langSet as $code){
			$pos = strpos($code,strtolower($clientsdetails["country"]));
			if ($pos !== false) {
				$countryCode = $code; 
			}
		}
		
		$postfields["task"] = "adduser";
		$postfields["firstname"] = $clientsdetails["firstname"];
		$postfields["lastname"] = $clientsdetails["lastname"];
		$postfields["languagecode"] = $clientsdetails["country"];
		$postfields["countrycode"] = $clientsdetails["country"];
		
		/* execute call */
		$res1 = api_execute($params["serverhostname"],$postfields);
		if(!is_array($res1)){
			$result = $res1;	
		}elseif($res1["result"] == "error"){
			foreach($res1["params"] as $code => $error){
				$result .= $code." - ".$error."<br />";
			}
		}else{
			#success array returned
			#echo "<pre>"; print_r($res); echo "</pre>";
			update_query("tblhosting",array("username" => $email,"password"=>encrypt($res1["params"]["password"])),array("id"=>$params["serviceid"]));
			$result = "success";
		}
	}
	return $result;
}

function cloudharddrive_TerminateAccount($params) {
		
	# Build the API call
	$postfields = array(); 
	$postfields["username"] = $params["serverusername"];
	$postfields["password"] = $params["serverpassword"];
	$postfields["service"] = "cloudharddrive";
	$postfields["reseller"] = $params["serveraccesshash"];		
	if($params["serversecure"] == "on"){ $postfields["testmode"] = "true"; }
	
	$postfields["task"] = "deleteuser";
	$postfields["email"] = $params["username"]; 	

	/* execute call */
	$res = api_execute($params["serverhostname"],$postfields);
	if(!is_array($res)){
		$result = $res;	
	}elseif($res["result"] == "error"){
		foreach($res["params"] as $code => $error){
			$result .= $code." - ".$error."<br />";
		}
	}else{
		#success array returned
		$result = "success";
	}
	return $result;
}

function cloudharddrive_SuspendAccount($params) {

	# Build the API call
	$postfields = array(); 
	$postfields["username"] = $params["serverusername"];
	$postfields["password"] = $params["serverpassword"];
	$postfields["service"] = "cloudharddrive";
	$postfields["reseller"] = $params["serveraccesshash"];		
	if($params["serversecure"] == "on"){ $postfields["testmode"] = "true"; }
	
	$postfields["task"] = "suspenduser";
	$postfields["email"] = $params["username"]; 	

	/* execute call */
	$res = api_execute($params["serverhostname"],$postfields);
	if(!is_array($res)){
		$result = $res;	
	}elseif($res["result"] == "error"){
		foreach($res["params"] as $code => $error){
			$result .= $code." - ".$error."<br />";
		}
	}else{
		#success array returned
		$result = "success";
	}
	return $result;
}

function cloudharddrive_UnsuspendAccount($params) {

	# Build the API call
	$postfields = array(); 
	$postfields["username"] = $params["serverusername"];
	$postfields["password"] = $params["serverpassword"];
	$postfields["service"] = "cloudharddrive";
	$postfields["reseller"] = $params["serveraccesshash"];		
	if($params["serversecure"] == "on"){ $postfields["testmode"] = "true"; }

	$postfields["task"] = "unsuspenduser";
	$postfields["email"] = $params["username"]; 	

	/* execute call */
	$res = api_execute($params["serverhostname"],$postfields);
	if(!is_array($res)){
		$result = $res;	
	}elseif($res["result"] == "error"){
		foreach($res["params"] as $code => $error){
			$result .= $code." - ".$error."<br />";
		}
	}else{
		#success array returned
		$result = "success";
	}
	return $result;
}

function cloudharddrive_ClientArea($params) {
	
	$code = '<form action="https://login.cloudharddrive.eu/logon/login/" name="login" id="login" method="post" target="_blank">
	<input type="hidden" name="data[Username]" value="'.$params["username"].'" />
	<input type="hidden" name="data[Password]" value="'.$params["password"].'" />
	<input type="submit" value="Login to Control Panel" />
	<input type="button" value="Helpdesk" target="_blank" onclick=\'window.open("http://cloudharddrive.eu/support/")\' />
	</form>';
	return $code;
}

?>